<?php
/**
* @version		1.2 from Beliyadm
* @copyright	Copyright (C) 2008 - 2009 Open Source Matters. All rights reserved.
*/
// no direct access
defined( '_JEXEC' ) or die( 'Прямой доступ запрещен' );
//register events
$mainframe->registerEvent('onPrepareContent', 'pb_spoiler');
//$plugin 		=& JPluginHelper::getPlugin('content', 'pb_spoiler');

function pb_spoiler_css()
	{
		global $mainframe;
		$language =& JFactory::getLanguage();
		JPlugin::loadLanguage('plg_pbspoiler', JPATH_ADMINISTRATOR);
		$config 		= & JFactory::getConfig();
		$plugin 		=& JPluginHelper::getPlugin('content', 'pb_spoiler');
		$pluginParams 	= new JParameter( $plugin->params );
		$jsjquery 		= $pluginParams->get('jsjquery', 1);
		$jsshow 		= $pluginParams->get('jsshow', 1);
		$jstype 		= $pluginParams->get('jstype', 1);
		$cssload 		= $pluginParams->get('cssload', 1);
		$revealtype		= $pluginParams->get('revealtype', 'click');
		$mouseoverdelay	= $pluginParams->get('mouseoverdelay', 200);
		$collapseprev	= $pluginParams->get('collapseprev', 0);
		$defaultexpanded	= $pluginParams->get('defaultexpanded', '');
		$onemustopen	= $pluginParams->get('onemustopen', 0);
		$animatedefault	= $pluginParams->get('animatedefault', 0);
		$persiststate	= $pluginParams->get('persiststate', 0);
		$animatespeed	= $pluginParams->get('animatespeed', 'fast');
		$togglehtml		= $pluginParams->get('togglehtml', 'none');
		if ($togglehtml == 'none'){
			$togglehtml1 = '';
			$togglehtml2 = '';
		}else{
			$togglehtml1	= $pluginParams->get('togglehtml1', '');
			$togglehtml2	= $pluginParams->get('togglehtml2', '');
		}
		$header 		= '';

		if (($jstype == 1) && includeOnce('Spoiler_Mootools')) {
			$document =& JFactory::getDocument();
			$document->addScript(JURI::base().'plugins/content/pb_spoiler/mootools/spoiler.js');
			$document->addStyleSheet(JURI::base().'plugins/content/pb_spoiler/mootools/spoiler.css');
		}
		if (($jstype == 2) && includeOnce('Spoiler_Jquery')) {
			$document =& JFactory::getDocument();
			if ($jsjquery == 1) {
				$document->addScript(JURI::base().'plugins/content/pb_spoiler/jquery/jquery.js');
			}
			$document->addScript(JURI::base().'plugins/content/pb_spoiler/jquery/ddaccordion.js');
			$jscode = '
	ddaccordion.init({
		headerclass: "technology",
		contentclass: "thelanguage",
		revealtype: "'.$revealtype.'",
		mouseoverdelay: '.$mouseoverdelay.',
		collapseprev: '.$collapseprev.',
		defaultexpanded: ['.$defaultexpanded.'],
		onemustopen: '.$onemustopen.',
		animatedefault: '.$animatedefault.',
		persiststate: '.$persiststate.',
		toggleclass: ["closedlanguage", "openlanguage"],
		togglehtml: ["'.$togglehtml.'", "'.$togglehtml1.'", "'.$togglehtml2.'"],
		animatespeed: "'.$animatespeed.'",
		oninit:function(expandedindices){
			//do nothing
		},
		onopenclose:function(header, index, state, isuseractivated){
			//do nothing
		}
	});';
			$document->addScriptDeclaration( $jscode );
			if ($cssload == 1) {
				$document->addStyleSheet(JURI::base().'plugins/content/pb_spoiler/jquery/style.css');
			}
		}
	}

function pb_spoiler(&$row, &$params)
	{
		$regex = "#{spoiler(?: title=(([_0-9A-Za-zА-яа-яЁё](.*?)))?)?}(.*?){/spoiler}#s";
		$row->text = preg_replace_callback( $regex, 'pb_spoiler_replacer', $row->text );
		return true;
	}

function pb_spoiler_replacer ( &$matches )
	{
		//$jstype = pb_spoiler_params();
		pb_spoiler_css();
		//нумерация каждого спойлера (если нужно)
//		global $numspoilers;
//		if(!$numspoilers){ $numspoilers = 1; }else{ $numspoilers++; }

		$plugin 		=& JPluginHelper::getPlugin('content', 'pb_spoiler');
		$pluginParams 	= new JParameter( $plugin->params );
	 	$jstype 		= $pluginParams->get('jstype', 1);
		$html 			= '';
		$regex1 = "#{spoiler title=([_0-9A-Za-zА-яа-яЁё](.*?))}#s";
		$regex2 = "#{/spoiler}#s";
		$spoilertext = preg_replace($regex2, '', (preg_replace($regex1, '', $matches[0])));

		switch ($jstype) {
			case '1'; //mootools
			$html .= '<div class="spoiler">
			<div class="sp-head">
			<div class="sp-head-click"><a href="#spoiler_0">'.$matches[1].'</a></div></div>
			<div class="sp-body">'.$spoilertext.'</div>
			</div>';
			break;
			case '2'; //jquery
//-------------------------------------------
//<a href="#" onClick="ddaccordion.collapseall('technology'); return false">Collapse all</a>  | <a href="#" onClick="ddaccordion.expandall('technology'); return false">Expand all</a> 
//
//<div class="technology">What is JavaScript?</div>
//<div class="thelanguage">JavaScript is a scripting language originally developed by Netscape to add interactivity and power to web documents. It is purely client side, and runs completely on the client's browser and computer.</div>
//
//<p><a href="currentpage.htm?technology=0,1,2">Reload page and select the 1st, 2nd, and 3rd contents using a URL parameter</a></p>
//-------------------------------------------
			$html .= '<div class="technology"><span>'.$matches[1].'</span></div><div class="thelanguage"><div class="thetextinter">'.$spoilertext.'</div></div>';
		 	break;
		}
        return $html;
	}

function includeOnce($name) {
	if (!defined($name)) {
		define($name, true);
		return true;
	}
	return false;
}
?>